﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Drawing
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();
            /*
            Bitmap bitmap = new Bitmap (pictureBox.Width, pictureBox.Height);
            pictureBox.Image = bitmap;

            Graphics g = Graphics.FromImage (bitmap);
            Brush b = new SolidBrush (Color.White);
            g.FillRectangle (b, 0, 0, bitmap.Width, bitmap.Height);
            */
            pictureBox_SizeChanged (null, null);
        }

        private void pictureBox_SizeChanged (object sender, EventArgs e)
        {
            Bitmap bitmap = new Bitmap (pictureBox.Width, pictureBox.Height);

            Graphics g = Graphics.FromImage (bitmap);

            Brush b = new SolidBrush (Color.White);
            g.FillRectangle(b, 0, 0, bitmap.Width, bitmap.Height);

            if (pictureBox.Image != null)
               g.DrawImage(pictureBox.Image, 0, 0);

            pictureBox.Image = bitmap;
        }

        private int X0, Y0;
        private bool down = false;
        private Bitmap save = null;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                Graphics g = Graphics.FromImage (pictureBox.Image);
                Brush b = new SolidBrush (Color.FromArgb(128, 128, 255));
                g.FillEllipse (b, e.X-5, e.Y-5, 11, 11);
                pictureBox.Invalidate();
            }
            else
            {
                X0 = e.X;
                Y0 = e.Y;
                down = true;
                save = new Bitmap (pictureBox.Image);
            }
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (down)
            {
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage(save, 0, 0);
                Pen p = new Pen(Color.FromArgb(128, 255, 128));
                p.Width = 1;
                g.DrawLine(p, X0, Y0, e.X, e.Y);
                pictureBox.Invalidate();
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                down = false;
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage (save, 0, 0);
                Pen p = new Pen(Color.FromArgb(255, 128, 128));
                p.Width = 5;
                g.DrawLine(p, X0, Y0, e.X, e.Y);
                pictureBox.Invalidate();
            }
        }

        private void fileToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void pictureBox_Click(object sender, EventArgs e)
        {

        }



    }
}
